#!/bin/sh 

###########################################################################
#
# /cluster/src/pov/1_clustv_pov.sh
# 23.12.2004 Fred Koegler
# Zum 29.01.2005 fuer die BraLUG - "Brandenburg Clusternight"
#
# Titelschrift, Logos, Vorschau auf Clusternight - Programm
# Verwendung als Trailer und Teilfilm #1 : Vorspann 
#
# notwendige Dateien:
# - /cluster/src/pov/clustv.ini
# - /cluster/src/pov/clustv.pov
# - /cluster/src/pov/Brandenburg_546x86_transparent.png
# - /cluster/src/pov/Clusternight_493x88_transparent.png
# - /cluster/src/pov/bralug_logo_orig.png
# - /cluster/src/tmp/clusta_01_001.png ... clusta_01_300.png
# - /cluster/src/pov/fred_logo_2004_1.png ... fred_logo_2004_7.png
# - /cluster/src/pov/clustp_615x460_splitted_with_numbers.png
# 
# Filmschnitt:
# - /cluster/src/pov/4_clusterfilm_mpeg.sh
# 
###########################################################################

# 01:  2.. 5 3s Titel ... Licht an 
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_01_ +KFI01 +KFF75 +KI2 +KF5
# 00:  0.. 2 2s Titel ohne Licht
# 02:  5.. 8 3s Titel anzeigen
# 03:  8..11 3s fredhase einschwenken   
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_03_ +KFI01 +KFF75 +KI8 +KF11
# 04: 11..14 3s fredhase anzeigen    
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_04_ +KFI00 +KFF07 +KI11 +KF14 +SF00 +EF00
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_04_ +KFI10 +KFF17 +KI11 +KF14 +SF11 +EF11
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_04_ +KFI20 +KFF27 +KI11 +KF14 +SF22 +EF22
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_04_ +KFI30 +KFF37 +KI11 +KF14 +SF33 +EF33
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_04_ +KFI40 +KFF47 +KI11 +KF14 +SF44 +EF44
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_04_ +KFI50 +KFF57 +KI11 +KF14 +SF55 +EF55
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_04_ +KFI60 +KFF67 +KI11 +KF14 +SF66 +EF66
# 05: 14..17 3s fredhase ausschwenken
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_05_ +KFI01 +KFF75 +KI14 +KF17
# 06: 17..20 3s Titel anzeigen
# 07: 20..23 3s animation einschwenken
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_07_ +KFI01 +KFF75 +KI20 +KF23
# 08: 23..29 6s animation anzeigen
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_08_ +KFI001 +KFF150 +KI23 +KF29
# 09: 29..32 3s animation ausschwenken
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_09_ +KFI01 +KFF75 +KI29 +KF32
# 10: 32..35 3s Titel anzeigen
# 11: 35..38 3s poster einschwenken
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_11_ +KFI01 +KFF75 +KI35 +KF38
# 12: 38..41 3s poster anzeigen
# 13: 41..44 3s poster ausschwenken
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_13_ +KFI01 +KFF75 +KI41 +KF44
# 14: 44..47 3s Titel anzeigen
# 15: 47..49 2s Titel ohne Licht anzeigen
# 53: 50..53 3s bralug einschwenken
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_53_ +KFI01 +KFF75 +KI50 +KF53
# 54: 53..56 3s bralug anzeigen    
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_54_ +KFI01 +KFF10 +KI53.001 +KF56 +SF01 +EF01
# 55: 56..59 3s bralug ausschwenken
povray /cluster/src/pov/clustv.ini +O/cluster/tmp/pov/clustv_55_ +KFI01 +KFF75 +KI56 +KF59
#