// ###########################################################################
// #
// # /cluster/src/pov/clustv.pov
// # 23.12.2004 Fred Koegler
// # Zum 29.01.2005 fuer die BraLUG - "Brandenburg Clusternight"
// #
// # Titelschrift, Logos, Vorschau auf Clusternight - Programm
// # Verwendung als Trailer und Teilfilm #1 : Vorspann 
// #
// # HOWTO:
// # - /cluster/src/pov/1_clustv_pov.sh
// #
// # speziell verwendete POVRay Elemente:
// # - rand & superellipsoid        : Sternenhimmel
// # - superellipsoid & image_map   : Schrift
// # - superellipsoid & image_map & rand & transparent : Schrifteinblendung
// # - image_map & transparent      : Bildeinblendung
// # 
// ###########################################################################
#version 3.1;

//#declare show_stars = 1;
//#declare build_title = 1;
//#declare show_title = 1;
//#declare show_fred = 1;
//#declare show_bralug = 1;
//#declare show_achterbahn = 1;
//#declare show_poster = 1;

#declare scene01_clock = 0.0;
#declare scene02_clock = 0.0;
#declare scene03_clock = 0.0;
#declare scene04_clock = 0.0;
#declare scene05_clock = 0.0;
#declare scene06_clock = 0.0;
#declare scene07_clock = 0.0;
#declare scene08_clock = 0.0;
#declare scene09_clock = 0.0;
#declare scene10_clock = 0.0;
#declare scene11_clock = 0.0;
#declare scene12_clock = 0.0;
#declare scene13_clock = 0.0;
#declare scene14_clock = 0.0;
#declare scene15_clock = 0.0;
#declare scene53_clock = 0.0;
#declare scene54_clock = 0.0;
#declare scene55_clock = 0.0;

#switch (clock)
//  #range (0,2) // scene 0: 2s Titel ohne Licht
  #range (2,5) // scene 1: 3s Titel ... Licht an 
    #declare show_stars = 1;
    #declare build_title = 1;
    #declare show_title = 1;
    #declare scene01_clock = (clock-2.0)/3.0;
    #debug concat("### clock:",str(clock,8,3)," -> 01: ",str(scene01_clock,8,3),"\n")
    #break
//  #range (5,8) // scene 2: 3s Titel anzeigen
  #range (8,11) // scene 3: 3s fredhase einschwenken   
    #declare show_stars = 1;
    #declare show_title = 1;
    #declare show_fred = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene03_clock = (clock-8.0+0.5*clock_delta)/3.0;
    #debug concat("### clock:",str(clock,8,3)," -> 03: ",str(scene03_clock,8,3),"\n")
    #break
  #range (11,13.9999) // scene 4: 3s fredhase anzeigen    
    #declare show_stars = 1;
    #declare show_title = 1;
    #declare show_fred = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene03_clock = 1.0;
    #declare scene04_clock = (clock-11.0)/3.0;
    #debug concat("### clock:",str(clock,8,3)," -> 04: ",str(scene04_clock,8,3),"\n")
    #break
  #range (14,17) // scene 5: 3s fredhase ausschwenken   
    #declare show_stars = 1;
    #declare show_title = 1;
    #declare show_fred = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene03_clock = 1.0;
    #declare scene04_clock = 1.0;
    #declare scene05_clock = (clock-14.0+0.5*clock_delta)/3.0;
    #debug concat("### clock:",str(clock,8,3)," -> 05: ",str(scene05_clock,8,3),"\n")
    #break
//  #range (17,20) // scene 6: 3s Titel anzeigen
  #range (20,22.9999) // scene 7: 3s animation einschwenken    
    #declare show_stars = 1;
    #declare show_title = 1;
    #declare show_achterbahn = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene03_clock = 1.0;
    #declare scene04_clock = 1.0;
    #declare scene05_clock = 1.0;
    #declare scene06_clock = 1.0;
    #declare scene07_clock = (clock-20.0+0.5*clock_delta)/3.0;
    #debug concat("### clock:",str(clock,8,3)," -> 07: ",str(scene07_clock,8,3),"\n")
    #declare scene_rotate = scene07_clock;
    #declare scene_factor = scene07_clock;
    #declare scene_img = 1+scene07_clock*75;
    #break
  #range (23,28.9999) // scene 8: 6s animation anzeigen    
    #declare show_stars = 1;
//    #declare show_title = 1;
    #declare show_achterbahn = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene03_clock = 1.0;
    #declare scene04_clock = 1.0;
    #declare scene05_clock = 1.0;
    #declare scene06_clock = 1.0;
    #declare scene07_clock = 1.0;
    #declare scene08_clock = (clock-23.0)/6.0;
    #debug concat("### clock:",str(clock,8,3)," -> 08: ",str(scene08_clock,8,3),"\n")
    #declare scene_rotate = 0;
    #declare scene_factor = 1;
    #declare scene_img = 1+75+scene08_clock*150;
    #break
  #range (29,32) // scene 9: 3s animation ausschwenken    
    #declare show_stars = 1;
    #declare show_title = 1;
    #declare show_achterbahn = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene03_clock = 1.0;
    #declare scene04_clock = 1.0;
    #declare scene05_clock = 1.0;
    #declare scene06_clock = 1.0;
    #declare scene07_clock = 1.0;
    #declare scene08_clock = 1.0;
    #declare scene09_clock = (clock-29.0+0.5*clock_delta)/3.0;
    #debug concat("### clock:",str(clock,8,3)," -> 09: ",str(scene09_clock,8,3),"\n")
    #declare scene_rotate = scene09_clock;
    #declare scene_factor = 1-scene09_clock;
    #declare scene_img = 1+75+150+scene09_clock*75;
    #break
//  #range (32,35) // scene 10: 3s Titel anzeigen
  #range (35,38) // scene 11: 3s poster einschwenken    
    #declare show_stars = 1;
    #declare show_title = 1;
    #declare show_poster = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene03_clock = 1.0;
    #declare scene04_clock = 1.0;
    #declare scene05_clock = 1.0;
    #declare scene06_clock = 1.0;
    #declare scene07_clock = 1.0;
    #declare scene08_clock = 1.0;
    #declare scene09_clock = 1.0;
    #declare scene10_clock = 1.0;
    #declare scene11_clock = (clock-35.0+0.5*clock_delta)/3.0;
    #debug concat("### clock:",str(clock,8,3)," -> 11: ",str(scene11_clock,8,3),"\n")
    #break
//  #range (38,41) // scene 12: 3s poster anzeigen    
  #range (41,44) // scene 13: 3s poster ausschwenken    
    #declare show_stars = 1;
    #declare show_title = 1;
    #declare show_poster = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene03_clock = 1.0;
    #declare scene04_clock = 1.0;
    #declare scene05_clock = 1.0;
    #declare scene06_clock = 1.0;
    #declare scene07_clock = 1.0;
    #declare scene08_clock = 1.0;
    #declare scene09_clock = 1.0;
    #declare scene10_clock = 1.0;
    #declare scene11_clock = 1.0;
    #declare scene12_clock = 1.0;
    #declare scene13_clock = (clock-41.0+0.5*clock_delta)/2.0;
    #debug concat("### clock:",str(clock,8,3)," -> 13: ",str(scene13_clock,8,3),"\n")
    #break
//  #range (44,47) // scene 14: 3s Titel anzeigen
//  #range (47,49) // scene 15: 2s Titel ohne Licht anzeigen
  #range (50,53) // scene 53: 3s bralug einschwenken   
    #declare show_stars = 1;
    #declare show_title = 1;
    #declare show_bralug = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene53_clock = (clock-50.0+0.5*clock_delta)/3.0;
    #debug concat("### clock:",str(clock,8,3)," -> 53: ",str(scene53_clock,8,3),"\n")
    #break
  #range (53,55.9999) // scene 54: 3s bralug anzeigen    
    #declare show_stars = 1;
    #declare show_title = 1;
    #declare show_bralug = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene53_clock = 1.0;
    #declare scene54_clock = (clock-53.0)/3.0;
    #debug concat("### clock:",str(clock,8,3)," -> 54: ",str(scene54_clock,8,3),"\n")
    #break
  #range (56,59) // scene 55: 3s bralug ausschwenken   
    #declare show_stars = 1;
    #declare show_title = 1;
    #declare show_bralug = 1;
    #declare scene01_clock = 1.0;
    #declare scene02_clock = 1.0;
    #declare scene53_clock = 1.0;
    #declare scene54_clock = 1.0;
    #declare scene55_clock = (clock-56.0+0.5*clock_delta)/3.0;
    #debug concat("### clock:",str(clock,8,3)," -> 55: ",str(scene55_clock,8,3),"\n")
    #break
#else
  #declare show_stars = 1; // Titel ohne Licht
  #declare show_title = 1;
#end 

global_settings
{
  adc_bailout 0.0039
  ambient_light color rgb 0
  assumed_gamma 1.0
  irid_wavelength <0.25, 0.18, 0.14>
  max_trace_level 6
}

// ############################################################################################################
#declare xyz_camera = <0,0,-5>;
#declare xyz_camera_look_at = <0,0,0>;
#declare xyz_camera_sky = <0,1,0>;
#declare xyz_camera_zoom = 1;
#declare xyz_camera_direction = xyz_camera_zoom*vnormalize(xyz_camera_look_at-xyz_camera);
#declare xyz_camera_look_at_vector = xyz_camera_direction*vlength(xyz_camera_look_at-xyz_camera);
   #declare CamL = xyz_camera;
   #declare CamD = vnormalize(xyz_camera_look_at-CamL);
   #declare CamR = vnormalize(vcross(xyz_camera_sky,CamD));
   #declare CamU = vnormalize(vcross(CamD,CamR));

   camera {
     direction xyz_camera_direction
     right CamR*4./3.
     up xyz_camera_sky
     location xyz_camera
   }

// ############################################################################################################
#declare sonne = light_source { <0,0,0>, colour rgb <1,.75,.15> }
object { sonne translate .1*<-500,+1000,-1000> }
object { sonne translate .1*<+500,+1000,-1000> }
object { sonne translate .1*<-500,-1000,-1000> }
object { sonne translate .1*<+500,-1000,-1000> }

#declare sonne = light_source { <0,0,0>, colour rgb 1 }
object { sonne translate .1*<-500,+1000,-1000> }
object { sonne translate .1*<+500,+1000,-1000> }
object { sonne translate .1*<-500,-1000,-1000> }
object { sonne translate .1*<+500,-1000,-1000> }

// ############################################################################################################
#declare SkyBlue = color red 0.196078 green 0.6 blue 0.8;
#declare MidnightBlue = color red 0.184314 green 0.184314 blue 0.309804;
sky_sphere 
{
  pigment 
  {
    gradient y
    color_map 
    {
      [ 0.1  color 0.001*SkyBlue ]
      [ 0.4  color 0.001*SkyBlue ]
      [ 0.9  color 0.001*MidnightBlue ]
      [ 1.0  color 0.001*MidnightBlue ]
    }
    scale 2
    translate -1
  }
}

// ############################################################################################################
#ifdef (show_stars)
  #declare dist = 200;
  #declare star_start = 246;
  #declare rrr0 = seed(star_start);
  #declare i = 0;
  #while (i < 50)
    union
    {
      superellipsoid { <10+10*rand(rrr0), 10+10*rand(rrr0)> }
      superellipsoid { <10+10*rand(rrr0), 10+10*rand(rrr0)> rotate <0,45,0> rotate <45,0,0> }
      no_shadow
      scale 2.0*<.25+.15*rand(rrr0),.25+.15*rand(rrr0),1> * dist/5.
      rotate <0,30*(-0.5+1*rand(rrr0)),30*(-0.5+1*rand(rrr0))>
      texture { pigment { color rgb .33 } }
      finish { metallic ambient 25 }

      #declare vec_to_star = (1.75+0.25*rand(rrr0)) * vnormalize(xyz_camera_look_at-xyz_camera) * dist;
      #declare vis_wink = 12*degrees(atan2(.5/vlength(vec_to_star),1)) * dist/5.;
      translate xyz_camera+vaxis_rotate(vaxis_rotate(vec_to_star,<1,0,0>,1.3333*vis_wink*(-0.5+1.0*rand(rrr0))),<0,1,0>,2*vis_wink*(-0.5+1.0*rand(rrr0)))
    }
    #declare i = i + 1;
  #end
#end

// ############################################################################################################
#ifdef (show_title)
  #declare rrr1 = seed(1);
  #declare bit = .041;

  #macro title_grid(zfac,xxx,yyy,yyy_tran,build,datei)
    #declare i_end = int(abs(zfac*vlength(xyz_camera_look_at_vector)*xxx/yyy/2./bit)+.999);
    #declare j_end = int(abs(zfac*vlength(xyz_camera_look_at_vector)/2./bit)+.999);

    #if (build <= 0)
      union
      {
    #end

      #declare i = 0;
      #while (i <= i_end) 
        #declare j = 0;
        #while (j <= j_end) 
          #declare rand_rrr1 = rand(rrr1);
          superellipsoid
          {
            <.5, .5>
            hollow no_shadow 

            #if (build <= 0)
              scale 0.85*<bit,bit,.001>
            #else
              scale 0.87*<bit,bit,.001>
              texture 
              { 
                pigment { color rgbt <0,0,0,sin(min(1,max(0,scene01_clock-0.8*rand_rrr1)*1/(1.001-0.8*rand_rrr1))*pi/2.)> }
                finish { ambient 0 diffuse 0 reflection 1 }
              }
              translate xyz_camera+xyz_camera_look_at_vector
              translate <0,yyy_tran,0>
            #end

            translate bit*<-i_end+2*i,-j_end+2*j,0> 
          }
          #declare j = j + 1;
        #end
        #declare i = i + 1;
      #end

      #if (build <= 0)
        texture 
        {
          pigment 
          {
            image_map { png datei map_type 0 once } 
            translate <-.5,-.5,0>
            scale zfac*vlength(xyz_camera_look_at_vector)*<xxx/yyy,1,1>
          }
          finish { ambient .9 diffuse 0.1 reflection 0 }
        }
        translate xyz_camera+xyz_camera_look_at_vector
        translate <0,yyy_tran,0>
      }
    #end

  #end

  title_grid(0.18,546,86,.7,0,"/cluster/src/pov/Brandenburg_546x86_transparent.png")
  title_grid(0.18,493,88,-.7,0,"/cluster/src/pov/Clusternight_493x88_transparent.png")

  #ifdef (build_title)
    title_grid(0.18,546,86,.7,1,"")
    title_grid(0.18,493,88,-.7,1,"")
  #end

#end //#ifdef (show_title)

// ############################################################################################################
#ifdef (show_bralug)
  #declare scene_factor = scene53_clock*(scene55_clock>0.0?(1.0-scene55_clock):1.0);
  box 
  {
    <0,0,0>, <1,1,.001>
    hollow no_shadow 
    texture 
    {
      pigment { image_map { png "/cluster/src/pov/bralug_logo_orig.png" map_type 0 once transmit all (0.5-0.5*scene_factor) } }
      finish { ambient .5+.5*scene_factor diffuse .175 reflection 0 }
    }
    translate <-.5,-.5,0>
    scale (0.0001+0.35*scene_factor)
    scale 0.5*vlength(xyz_camera_look_at-xyz_camera)*<725/277,1,1>
    translate xyz_camera+0.5*xyz_camera_look_at_vector
    translate .4*< (scene55_clock>0.0?+1:-1)*sin(scene_factor*pi), (scene05_clock>0.0?-1:+1)*sin(scene_factor*pi), 0 >
    rotate <0,0,15+(scene55_clock>0.0?+1:-1)*360*scene_factor>
  }
#end

// ############################################################################################################
#ifdef (show_fred)
  #declare scene_factor = scene03_clock*(scene05_clock>0.0?(1.0-scene05_clock):1.0);
  #if ((scene03_clock >= 1.0) & (scene04_clock < 1.0))
    #declare fred_img = concat("/cluster/src/pov/fred_logo_2004_",str(int(1.5+8*scene04_clock),1,0),".png");
#debug concat("### clock: ",str(scene04_clock,8,3)," -> img: ",fred_img,"\n")
  #else
    #declare fred_img = "/cluster/src/pov/fred_logo_2004_1.png";
  #end
  box 
  {
    <0,0,0>, <1,1,.00001>
    hollow no_shadow 
    texture 
    {
      pigment { image_map { png fred_img map_type 0 once transmit all (0.5-0.5*scene_factor) } }
      finish { ambient .5+.5*scene_factor diffuse .175 reflection 0 }
    }
    translate <-.5,-.5,0>
    scale (0.0001+0.55*scene_factor)
    scale 0.5*vlength(xyz_camera_look_at-xyz_camera)*<152/77,1,1>
    translate xyz_camera+0.5*xyz_camera_look_at_vector
    translate .4*< (scene05_clock>0.0?+1:-1)*sin(scene_factor*pi), (scene05_clock>0.0?-1:+1)*sin(scene_factor*pi), 0 >
    rotate <0,0,(scene05_clock>0.0?+1:-1)*(45+315*scene_factor)>
  }
#end

// ############################################################################################################
#ifdef (show_achterbahn)
  #declare achter_clock = int(scene_img+.499);
  #declare achter_img = concat("/cluster/src/tmp/clusta_01_",str(int(mod(achter_clock,1000)/100),1,0),str(int(mod(achter_clock,100)/10),1,0),str(int(mod(achter_clock,10)),1,0),".png");
#debug concat("### clock: ",str(scene_factor,8,3)," -> img: ",achter_img,"\n")
  box 
  {
    <0,0,0>, <1,1,.001>
    hollow no_shadow 
    texture 
    {
      pigment { image_map { png achter_img map_type 0 once transmit all (0.6-0.6*scene_factor) } }
      finish { ambient (.5+.35*scene_factor) diffuse .25 reflection 0 }
    }
    translate <-.5,-.5,0>
    scale (0.00001+0.88888*scene_factor)
    scale 0.5*vlength(xyz_camera_look_at-xyz_camera)*<640/480,1,1>
    translate xyz_camera+0.5*xyz_camera_look_at_vector
    rotate <0,0,-360*scene_rotate>
  }
#end

// ############################################################################################################
#ifdef (show_poster)
  #declare scene_factor = scene11_clock*(scene13_clock>0.0?(1.0-scene13_clock):1.0);
  #if (scene_factor > (1.-1./75.))
    #declare scene_factor = 1.0;
  #end

  #if (scene13_clock<=0.0)
    #declare rposter = seed(1);
    #declare i_end = 5.;
    #declare j_end = 5.;
    #declare i = 0.;
    #while (i < i_end) 
      #declare j = 0.;
      #while (j < j_end)
        #declare rp1 = 0.95*rand(rposter);
//#debug concat("###",str(scene_factor,8,3),", ",str(i,1,0),", ",str(j,1,0),", ",str(rp1,8,3),"\n")
        #if (scene_factor > (0.5*rp1))
          #declare rp1 = min(1,max(0.0025,2.0*(scene_factor-0.5*rp1)));
#if (rp1 < 1)
#debug concat("###",str(scene_factor,8,3),", ",str(i,1,0),", ",str(j,1,0),", ",str(rp1,8,3),"\n")
#end
          box 
          {
            <i/i_end,j/j_end,0>, <(i+1.)/i_end,(j+1.)/j_end,.001>
            hollow no_shadow 
            texture 
            {
              pigment { image_map { png "/cluster/src/pov/clusternight_poster_640x480_splitted_with_numbers.png" map_type 0 once transmit all (0.76-0.76*rp1) } }
              finish { ambient (.5+.5*rp1) diffuse .15 reflection 0 }
            }
            translate <-.5,-.5,0>
            scale (0.18888+0.7*rp1)
            scale 0.5*vlength(xyz_camera_look_at_vector)*<640/480,1,1>
            translate xyz_camera+(0.5*(1+.1*(1-rp1)))*xyz_camera_look_at_vector
          }
        #end
        #declare j = j + 1.;
      #end
      #declare i = i + 1.;
    #end
  #else
    box 
    {
      <0,0,0>, <1,1,.00001>
      hollow no_shadow 
      texture 
      {
        pigment { image_map { png "/cluster/src/pov/clusternight_poster_640x480_splitted_with_numbers.png" map_type 0 once transmit all (0.66-0.66*scene_factor) } }
        finish { ambient (.5+.5*scene_factor) diffuse .15 reflection 0 }
      }
      translate <-.5,-.5,0>
      scale (0.38888+0.5*scene_factor)
      scale 0.5*vlength(xyz_camera_look_at-xyz_camera)*<640/480,1,1>
      translate xyz_camera+0.5*xyz_camera_look_at_vector
    }
  #end
#end
